Index: xorg-server-7.2.0.0-1.5.99.1/Xext/panoramiX.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/Xext/panoramiX.c
+++ xorg-server-7.2.0.0-1.5.99.1/Xext/panoramiX.c
@@ -53,9 +53,18 @@ Equipment Corporation.
 #include "globals.h"
 #include "servermd.h"
 #include "resource.h"
+#ifdef MITSHM
+#include "shmint.h"
+#endif
 #ifdef RENDER
 #include "picturestr.h"
 #endif
+#ifdef XFIXES
+#include "xfixesint.h"
+#endif
+#ifdef COMPOSITE
+#include "compint.h"
+#endif
 #include "modinit.h"
 
 
@@ -577,9 +586,19 @@ void PanoramiXExtensionInit(int argc, ch
     ProcVector[X_StoreColors] = PanoramiXStoreColors;    
     ProcVector[X_StoreNamedColor] = PanoramiXStoreNamedColor;    
 
+#ifdef MITSHM
+    PanoramiXShmInit ();
+#endif
 #ifdef RENDER
     PanoramiXRenderInit ();
 #endif
+#ifdef XFIXES
+    PanoramiXFixesInit ();
+#endif
+#ifdef COMPOSITE
+    PanoramiXCompositeInit ();
+#endif
+
 }
 
 extern Bool CreateConnectionBlock(void);
@@ -888,6 +907,9 @@ static void PanoramiXResetProc(Extension
 #ifdef RENDER
     PanoramiXRenderReset ();
 #endif
+#ifdef XFIXES
+    PanoramiXFixesReset ();
+#endif
     screenInfo.numScreens = PanoramiXNumScreens;
     for (i = 256; i--; )
 	ProcVector[i] = SavedProcVector[i];
Index: xorg-server-7.2.0.0-1.5.99.1/Xext/panoramiX.h
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/Xext/panoramiX.h
+++ xorg-server-7.2.0.0-1.5.99.1/Xext/panoramiX.h
@@ -69,7 +69,8 @@ typedef struct {
 	} pix;
 #ifdef RENDER
 	struct {
-	    Bool root;
+	    char root;
+	    char sourcePict;
 	} pict;
 #endif
 	char raw_data[4];
Index: xorg-server-7.2.0.0-1.5.99.1/Xext/panoramiXprocs.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/Xext/panoramiXprocs.c
+++ xorg-server-7.2.0.0-1.5.99.1/Xext/panoramiXprocs.c
@@ -981,18 +981,20 @@ int PanoramiXCopyArea(ClientPtr client)
     Bool		srcIsRoot = FALSE;
     Bool		dstIsRoot = FALSE;
     Bool		srcShared, dstShared;
+    Bool		getImageData = FALSE;
+    DrawablePtr		srcDrawables[MAXSCREENS];
     REQUEST(xCopyAreaReq);
 
     REQUEST_SIZE_MATCH(xCopyAreaReq);
 
     if(!(src = (PanoramiXRes *)SecurityLookupIDByClass(
-		client, stuff->srcDrawable, XRC_DRAWABLE, DixReadAccess)))
+	     client, stuff->srcDrawable, XRC_DRAWABLE, DixReadAccess)))
 	return BadDrawable;
 
     srcShared = IS_SHARED_PIXMAP(src);
 
     if(!(dst = (PanoramiXRes *)SecurityLookupIDByClass(
-		client, stuff->dstDrawable, XRC_DRAWABLE, DixWriteAccess)))
+	     client, stuff->dstDrawable, XRC_DRAWABLE, DixWriteAccess)))
 	return BadDrawable;
 
     dstShared = IS_SHARED_PIXMAP(dst);
@@ -1000,6 +1002,17 @@ int PanoramiXCopyArea(ClientPtr client)
     if(dstShared && srcShared)
 	return (* SavedProcVector[X_CopyArea])(client);
 
+    if (stuff->dstDrawable != stuff->srcDrawable) {
+	int rc;
+
+	FOR_NSCREENS(j) {
+	    rc = dixLookupDrawable(srcDrawables+j, src->info[j].id, client, 0,
+				   DixGetAttrAccess);
+	    if (rc != Success)
+		return rc;
+	}
+    }
+
     if(!(gc = (PanoramiXRes *)SecurityLookupIDByType(
 		client, stuff->gc, XRT_GC, DixReadAccess)))
 	return BadGC;
@@ -1011,32 +1024,34 @@ int PanoramiXCopyArea(ClientPtr client)
 
     srcx = stuff->srcX; srcy = stuff->srcY;
     dstx = stuff->dstX; dsty = stuff->dstY;
+
     if((dst->type == XRT_PIXMAP) && (src->type == XRT_WINDOW)) {
-	DrawablePtr drawables[MAXSCREENS];
+	WindowPtr pWin = (WindowPtr) srcDrawables[0];
+
+	/* no need to use GetImageData if window is redirected */
+	for (getImageData = TRUE; pWin && getImageData; pWin = pWin->parent)
+	    if (pWin->redirectDraw != RedirectDrawNone)
+		getImageData = FALSE;
+    }
+
+    if(getImageData) {
 	DrawablePtr pDst;
 	GCPtr pGC;
         char *data;
-	int pitch, rc;
-
-	FOR_NSCREENS(j) {
-	    rc = dixLookupDrawable(drawables+j, src->info[j].id, client, 0,
-				   DixGetAttrAccess);
-	    if (rc != Success)
-		return rc;
-	}
+	int pitch;
 
-	pitch = PixmapBytePad(stuff->width, drawables[0]->depth); 
+	pitch = PixmapBytePad(stuff->width, srcDrawables[0]->depth); 
 	if(!(data = xcalloc(1, stuff->height * pitch)))
 	    return BadAlloc;
 
-	XineramaGetImageData(drawables, srcx, srcy, 
+	XineramaGetImageData(srcDrawables, srcx, srcy, 
 		stuff->width, stuff->height, ZPixmap, ~0, data, pitch, 
 		srcIsRoot);
 
 	FOR_NSCREENS_BACKWARD(j) {
 	    stuff->gc = gc->info[j].id;
 	    VALIDATE_DRAWABLE_AND_GC(dst->info[j].id, pDst, DixWriteAccess);
-	    if(drawables[0]->depth != pDst->depth) {
+	    if(srcDrawables[0]->depth != pDst->depth) {
 		client->errorValue = stuff->dstDrawable;
 		xfree(data);
 		return (BadMatch);
@@ -1056,7 +1071,6 @@ int PanoramiXCopyArea(ClientPtr client)
 	DrawablePtr pDst = NULL, pSrc = NULL;
 	GCPtr pGC = NULL;
 	RegionPtr pRgn[MAXSCREENS];
-	int rc;
 
 	FOR_NSCREENS_BACKWARD(j) {
 	    stuff->dstDrawable = dst->info[j].id;
@@ -1074,11 +1088,7 @@ int PanoramiXCopyArea(ClientPtr client)
 	    VALIDATE_DRAWABLE_AND_GC(stuff->dstDrawable, pDst, DixWriteAccess);
 
 	    if (stuff->dstDrawable != stuff->srcDrawable) {
-		rc = dixLookupDrawable(&pSrc, stuff->srcDrawable, client, 0,
-				       DixReadAccess);
-		if (rc != Success)
-		    return rc;
-
+		pSrc = srcDrawables[j];
 		if ((pDst->pScreen != pSrc->pScreen) || 
 		    (pDst->depth != pSrc->depth)) {
 			client->errorValue = stuff->dstDrawable;
@@ -1749,6 +1759,7 @@ int PanoramiXGetImage(ClientPtr client)
 {
     DrawablePtr 	drawables[MAXSCREENS];
     DrawablePtr 	pDraw;
+    WindowPtr		pWin;
     PanoramiXRes	*draw;
     xGetImageReply	xgi;
     Bool		isRoot;
@@ -1782,6 +1793,11 @@ int PanoramiXGetImage(ClientPtr client)
     if(!((WindowPtr)pDraw)->realized)
 	return(BadMatch);
 
+    /* bits for redirected windows are available on all screens */
+    for (pWin = (WindowPtr) pDraw; pWin; pWin = pWin->parent)
+	if (pWin->redirectDraw != RedirectDrawNone)
+	    return (*SavedProcVector[X_GetImage])(client);
+
     x = stuff->x;
     y = stuff->y;
     w = stuff->width;
Index: xorg-server-7.2.0.0-1.5.99.1/Xext/shm.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/Xext/shm.c
+++ xorg-server-7.2.0.0-1.5.99.1/Xext/shm.c
@@ -90,16 +90,9 @@ in this Software without prior written a
 #include "panoramiXsrv.h"
 #endif
 
-#include "modinit.h"
+int (*PanoramiXSaveShmVector[ShmNumberRequests])(ClientPtr);
 
-typedef struct _ShmDesc {
-    struct _ShmDesc *next;
-    int shmid;
-    int refcnt;
-    char *addr;
-    Bool writable;
-    unsigned long size;
-} ShmDescRec, *ShmDescPtr;
+#include "modinit.h"
 
 static void miShmPutImage(XSHM_PUT_IMAGE_ARGS);
 static PixmapPtr fbShmCreatePixmap(XSHM_CREATE_PIXMAP_ARGS);
@@ -132,7 +125,25 @@ static DISPATCH_PROC(SProcShmGetImage);
 static DISPATCH_PROC(SProcShmPutImage);
 static DISPATCH_PROC(SProcShmQueryVersion);
 
-static unsigned char ShmReqCode;
+int (*ProcShmVector[ShmNumberRequests])(ClientPtr) = {
+    ProcShmQueryVersion,
+    ProcShmAttach,
+    ProcShmDetach,
+    ProcShmPutImage,
+    ProcShmGetImage,
+    ProcShmCreatePixmap
+};
+
+int (*SProcShmVector[ShmNumberRequests])(ClientPtr) = {
+    SProcShmQueryVersion,
+    SProcShmAttach,
+    SProcShmDetach,
+    SProcShmPutImage,
+    SProcShmGetImage,
+    SProcShmCreatePixmap
+};
+
+_X_EXPORT unsigned char ShmReqCode;
 _X_EXPORT int ShmCompletionCode;
 _X_EXPORT int BadShmSegCode;
 _X_EXPORT RESTYPE ShmSegType;
@@ -146,37 +157,6 @@ static DevPrivateKey shmPixmapPrivate =
 static ShmFuncs miFuncs = {NULL, miShmPutImage};
 static ShmFuncs fbFuncs = {fbShmCreatePixmap, fbShmPutImage};
 
-#define VERIFY_SHMSEG(shmseg,shmdesc,client) \
-{ \
-    shmdesc = (ShmDescPtr)LookupIDByType(shmseg, ShmSegType); \
-    if (!shmdesc) \
-    { \
-	client->errorValue = shmseg; \
-	return BadShmSegCode; \
-    } \
-}
-
-#define VERIFY_SHMPTR(shmseg,offset,needwrite,shmdesc,client) \
-{ \
-    VERIFY_SHMSEG(shmseg, shmdesc, client); \
-    if ((offset & 3) || (offset > shmdesc->size)) \
-    { \
-	client->errorValue = offset; \
-	return BadValue; \
-    } \
-    if (needwrite && !shmdesc->writable) \
-	return BadAccess; \
-}
-
-#define VERIFY_SHMSIZE(shmdesc,offset,len,client) \
-{ \
-    if ((offset + len) > shmdesc->size) \
-    { \
-	return BadAccess; \
-    } \
-}
-
-
 #if defined(__FreeBSD__) || defined(__NetBSD__) || defined(__OpenBSD__) || defined(__CYGWIN__) || defined(__DragonFly__)
 #include <sys/signal.h>
 
@@ -591,7 +571,7 @@ ProcPanoramiXShmPutImage(ClientPtr clien
     orig_y = stuff->dstY;
     sendEvent = stuff->sendEvent;
     stuff->sendEvent = 0;
-    FOR_NSCREENS(j) {
+    FOR_NSCREENS_BACKWARD(j) {
 	if(!j) stuff->sendEvent = sendEvent;
 	stuff->drawable = draw->info[j].id;
 	stuff->gc = gc->info[j].id;
@@ -599,7 +579,7 @@ ProcPanoramiXShmPutImage(ClientPtr clien
 	    stuff->dstX = orig_x - panoramiXdataPtr[j].x;
 	    stuff->dstY = orig_y - panoramiXdataPtr[j].y;
 	}
-	result = ProcShmPutImage(client);
+	result = (*PanoramiXSaveShmVector[X_ShmPutImage])(client);
 	if(result != client->noClientException) break;
     }
     return(result);
@@ -611,6 +591,7 @@ ProcPanoramiXShmGetImage(ClientPtr clien
     PanoramiXRes	*draw;
     DrawablePtr 	drawables[MAXSCREENS];
     DrawablePtr 	pDraw;
+    WindowPtr		pWin;
     xShmGetImageReply	xgi;
     ShmDescPtr		shmdesc;
     int         	i, x, y, w, h, format, rc;
@@ -632,13 +613,18 @@ ProcPanoramiXShmGetImage(ClientPtr clien
 	return BadDrawable;
 
     if (draw->type == XRT_PIXMAP)
-	return ProcShmGetImage(client);
+	return (*PanoramiXSaveShmVector[X_ShmGetImage])(client);
 
     rc = dixLookupDrawable(&pDraw, stuff->drawable, client, 0,
 			   DixReadAccess);
     if (rc != Success)
 	return rc;
 
+    /* bits for redirected windows are available on all screens */
+    for (pWin = (WindowPtr) pDraw; pWin; pWin = pWin->parent)
+	if (pWin->redirectDraw != RedirectDrawNone)
+	    return (*PanoramiXSaveShmVector[X_ShmGetImage])(client);
+
     VERIFY_SHMPTR(stuff->shmseg, stuff->offset, TRUE, shmdesc, client);
 
     x = stuff->x;
@@ -1160,35 +1146,11 @@ static int
 ProcShmDispatch (ClientPtr client)
 {
     REQUEST(xReq);
-    switch (stuff->data)
-    {
-    case X_ShmQueryVersion:
-	return ProcShmQueryVersion(client);
-    case X_ShmAttach:
-	return ProcShmAttach(client);
-    case X_ShmDetach:
-	return ProcShmDetach(client);
-    case X_ShmPutImage:
-#ifdef PANORAMIX
-        if ( !noPanoramiXExtension )
-	   return ProcPanoramiXShmPutImage(client);
-#endif
-	return ProcShmPutImage(client);
-    case X_ShmGetImage:
-#ifdef PANORAMIX
-        if ( !noPanoramiXExtension )
-	   return ProcPanoramiXShmGetImage(client);
-#endif
-	return ProcShmGetImage(client);
-    case X_ShmCreatePixmap:
-#ifdef PANORAMIX
-        if ( !noPanoramiXExtension )
-	   return ProcPanoramiXShmCreatePixmap(client);
-#endif
-	   return ProcShmCreatePixmap(client);
-    default:
+
+    if (stuff->data < ShmNumberRequests)
+	return (*ProcShmVector[stuff->data]) (client);
+    else
 	return BadRequest;
-    }
 }
 
 static void
@@ -1210,7 +1172,7 @@ SProcShmQueryVersion(ClientPtr client)
     REQUEST(xShmQueryVersionReq);
 
     swaps(&stuff->length, n);
-    return ProcShmQueryVersion(client);
+    return (*ProcShmVector[stuff->shmReqType])(client);
 }
 
 static int
@@ -1222,7 +1184,7 @@ SProcShmAttach(ClientPtr client)
     REQUEST_SIZE_MATCH(xShmAttachReq);
     swapl(&stuff->shmseg, n);
     swapl(&stuff->shmid, n);
-    return ProcShmAttach(client);
+    return (*ProcShmVector[stuff->shmReqType])(client);
 }
 
 static int
@@ -1233,7 +1195,7 @@ SProcShmDetach(ClientPtr client)
     swaps(&stuff->length, n);
     REQUEST_SIZE_MATCH(xShmDetachReq);
     swapl(&stuff->shmseg, n);
-    return ProcShmDetach(client);
+    return (*ProcShmVector[stuff->shmReqType])(client);
 }
 
 static int
@@ -1255,7 +1217,7 @@ SProcShmPutImage(ClientPtr client)
     swaps(&stuff->dstY, n);
     swapl(&stuff->shmseg, n);
     swapl(&stuff->offset, n);
-    return ProcShmPutImage(client);
+    return (*ProcShmVector[stuff->shmReqType])(client);
 }
 
 static int
@@ -1273,7 +1235,7 @@ SProcShmGetImage(ClientPtr client)
     swapl(&stuff->planeMask, n);
     swapl(&stuff->shmseg, n);
     swapl(&stuff->offset, n);
-    return ProcShmGetImage(client);
+    return (*ProcShmVector[stuff->shmReqType])(client);
 }
 
 static int
@@ -1289,28 +1251,45 @@ SProcShmCreatePixmap(ClientPtr client)
     swaps(&stuff->height, n);
     swapl(&stuff->shmseg, n);
     swapl(&stuff->offset, n);
-    return ProcShmCreatePixmap(client);
+    return (*ProcShmVector[stuff->shmReqType])(client);
 }
 
 static int
 SProcShmDispatch (ClientPtr client)
 {
     REQUEST(xReq);
-    switch (stuff->data)
-    {
-    case X_ShmQueryVersion:
-	return SProcShmQueryVersion(client);
-    case X_ShmAttach:
-	return SProcShmAttach(client);
-    case X_ShmDetach:
-	return SProcShmDetach(client);
-    case X_ShmPutImage:
-	return SProcShmPutImage(client);
-    case X_ShmGetImage:
-	return SProcShmGetImage(client);
-    case X_ShmCreatePixmap:
-	return SProcShmCreatePixmap(client);
-    default:
+
+    if (stuff->data < ShmNumberRequests)
+	return (*SProcShmVector[stuff->data]) (client);
+    else
 	return BadRequest;
-    }
 }
+
+#ifdef PANORAMIX
+
+void
+PanoramiXShmInit (void)
+{
+    int i;
+    
+    for (i = 0; i < ShmNumberRequests; i++)
+	PanoramiXSaveShmVector[i] = ProcShmVector[i];
+
+    /*
+     * Stuff in Xinerama aware request processing hooks
+     */
+    ProcShmVector[X_ShmPutImage]     = ProcPanoramiXShmPutImage;
+    ProcShmVector[X_ShmGetImage]     = ProcPanoramiXShmGetImage;
+    ProcShmVector[X_ShmCreatePixmap] = ProcPanoramiXShmCreatePixmap;
+}
+
+void
+PanoramiXShmReset (void)
+{
+    int i;
+
+    for (i = 0; i < ShmNumberRequests; i++)
+	ProcShmVector[i] = PanoramiXSaveShmVector[i];
+}
+
+#endif	/* PANORAMIX */
Index: xorg-server-7.2.0.0-1.5.99.1/Xext/shmint.h
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/Xext/shmint.h
+++ xorg-server-7.2.0.0-1.5.99.1/Xext/shmint.h
@@ -30,6 +30,54 @@
 #include "pixmap.h"
 #include "gc.h"
 
+#ifndef ShmNumberRequests
+#define ShmNumberRequests (X_ShmCreatePixmap + 1)
+#endif
+
+typedef struct _ShmDesc {
+    struct _ShmDesc *next;
+    int shmid;
+    int refcnt;
+    char *addr;
+    Bool writable;
+    unsigned long size;
+} ShmDescRec, *ShmDescPtr;
+
+extern unsigned char ShmReqCode;
+extern int ShmCompletionCode;
+extern int BadShmSegCode;
+extern RESTYPE ShmSegType;
+
+#define VERIFY_SHMSEG(shmseg,shmdesc,client) \
+{ \
+    shmdesc = (ShmDescPtr)LookupIDByType(shmseg, ShmSegType); \
+    if (!shmdesc) \
+    { \
+	client->errorValue = shmseg; \
+	return BadShmSegCode; \
+    } \
+}
+
+#define VERIFY_SHMPTR(shmseg,offset,needwrite,shmdesc,client) \
+{ \
+    VERIFY_SHMSEG(shmseg, shmdesc, client); \
+    if ((offset & 3) || (offset > shmdesc->size)) \
+    { \
+	client->errorValue = offset; \
+	return BadValue; \
+    } \
+    if (needwrite && !shmdesc->writable) \
+	return BadAccess; \
+}
+
+#define VERIFY_SHMSIZE(shmdesc,offset,len,client) \
+{ \
+    if ((offset + len) > shmdesc->size) \
+    { \
+	return BadAccess; \
+    } \
+}
+
 void
 ShmRegisterFuncs(ScreenPtr pScreen, ShmFuncsPtr funcs);
 
@@ -42,4 +90,9 @@ fbShmPutImage(XSHM_PUT_IMAGE_ARGS);
 void
 ShmRegisterFbFuncs(ScreenPtr pScreen);
 
+#ifdef PANORAMIX
+void PanoramiXShmInit (void);
+void PanoramiXShmReset (void);
+#endif
+
 #endif /* _SHMINT_H_ */
Index: xorg-server-7.2.0.0-1.5.99.1/Xi/extinit.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/Xi/extinit.c
+++ xorg-server-7.2.0.0-1.5.99.1/Xi/extinit.c
@@ -173,7 +173,7 @@ XExtEventInfo EventInfo[32];
  * Dispatch vector. Functions defined in here will be called when the matching
  * request arrives.
  */
-static int (*ProcIVector[])(ClientPtr) = {
+int (*ProcIVector[])(ClientPtr) = {
         NULL,                                   /*  0 */
 	ProcXGetExtensionVersion,               /*  1 */
 	ProcXListInputDevices,                  /*  2 */
@@ -229,7 +229,7 @@ static int (*ProcIVector[])(ClientPtr) =
 };
 
 /* For swapped clients */
-static int (*SProcIVector[])(ClientPtr) = {
+int (*SProcIVector[])(ClientPtr) = {
         NULL,                                    /*  0 */
 	SProcXGetExtensionVersion,               /*  1 */
 	SProcXListInputDevices,                  /*  2 */
Index: xorg-server-7.2.0.0-1.5.99.1/composite/compext.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/composite/compext.c
+++ xorg-server-7.2.0.0-1.5.99.1/composite/compext.c
@@ -143,6 +143,7 @@ ProcCompositeRedirectWindow (ClientPtr c
     REQUEST(xCompositeRedirectWindowReq);
 
     REQUEST_SIZE_MATCH(xCompositeRedirectWindowReq);
+
     rc = dixLookupResource((pointer *)&pWin, stuff->window, RT_WINDOW, client,
 			   DixSetAttrAccess|DixManageAccess|DixBlendAccess);
     if (rc != Success)
@@ -161,6 +162,7 @@ ProcCompositeRedirectSubwindows (ClientP
     REQUEST(xCompositeRedirectSubwindowsReq);
 
     REQUEST_SIZE_MATCH(xCompositeRedirectSubwindowsReq);
+
     rc = dixLookupResource((pointer *)&pWin, stuff->window, RT_WINDOW, client,
 			   DixSetAttrAccess|DixManageAccess|DixBlendAccess);
     if (rc != Success)
@@ -178,6 +180,7 @@ ProcCompositeUnredirectWindow (ClientPtr
     REQUEST(xCompositeUnredirectWindowReq);
 
     REQUEST_SIZE_MATCH(xCompositeUnredirectWindowReq);
+
     pWin = (WindowPtr) LookupIDByType (stuff->window, RT_WINDOW);
     if (!pWin)
     {
@@ -194,6 +197,7 @@ ProcCompositeUnredirectSubwindows (Clien
     REQUEST(xCompositeUnredirectSubwindowsReq);
 
     REQUEST_SIZE_MATCH(xCompositeUnredirectSubwindowsReq);
+
     pWin = (WindowPtr) LookupIDByType (stuff->window, RT_WINDOW);
     if (!pWin)
     {
@@ -249,6 +253,7 @@ ProcCompositeNameWindowPixmap (ClientPtr
     REQUEST(xCompositeNameWindowPixmapReq);
 
     REQUEST_SIZE_MATCH(xCompositeNameWindowPixmapReq);
+
     rc = dixLookupResource((pointer *)&pWin, stuff->window, RT_WINDOW, client,
 			   DixGetAttrAccess);
     if (rc != Success)
@@ -297,6 +302,7 @@ ProcCompositeGetOverlayWindow (ClientPtr
     int rc;
 
     REQUEST_SIZE_MATCH(xCompositeGetOverlayWindowReq);
+
     rc = dixLookupResource((pointer *)&pWin, stuff->window, RT_WINDOW, client,
 			   DixGetAttrAccess);
     if (rc != Success)
@@ -359,6 +365,7 @@ ProcCompositeReleaseOverlayWindow (Clien
     CompOverlayClientPtr pOc;
 
     REQUEST_SIZE_MATCH(xCompositeReleaseOverlayWindowReq);
+
     pWin = (WindowPtr) LookupIDByType (stuff->window, RT_WINDOW);
     if (!pWin)
     {
@@ -381,7 +388,7 @@ ProcCompositeReleaseOverlayWindow (Clien
     return client->noClientException;
 }
 
-static int (*ProcCompositeVector[CompositeNumberRequests])(ClientPtr) = {
+int (*ProcCompositeVector[CompositeNumberRequests])(ClientPtr) = {
     ProcCompositeQueryVersion,
     ProcCompositeRedirectWindow,
     ProcCompositeRedirectSubwindows,
@@ -565,13 +572,6 @@ CompositeExtensionInit (void)
 	if (GetPictureScreenIfSet(pScreen) == NULL)
 	    return;
     }
-#ifdef PANORAMIX
-    /* Xinerama's rewriting of window drawing before Composite gets to it
-     * breaks Composite.
-     */
-    if (!noPanoramiXExtension)
-	return;
-#endif
 
     CompositeClientWindowType = CreateNewResourceType (FreeCompositeClientWindow);
     if (!CompositeClientWindowType)
@@ -607,3 +607,357 @@ CompositeExtensionInit (void)
     /* Initialization succeeded */
     noCompositeExtension = FALSE;
 }
+
+#ifdef PANORAMIX
+#include "panoramiX.h"
+extern unsigned long XRT_PIXMAP;
+extern unsigned long XRT_WINDOW;
+extern int           PanoramiXNumScreens;
+
+int (*PanoramiXSaveCompositeVector[CompositeNumberRequests]) (ClientPtr);
+
+static int
+PanoramiXCompositeRedirectWindow (ClientPtr client)
+{
+    PanoramiXRes *win;
+    int rc = 0, j;
+    REQUEST(xCompositeRedirectWindowReq);
+
+    REQUEST_SIZE_MATCH(xCompositeRedirectWindowReq);
+
+    if(!(win = (PanoramiXRes *)SecurityLookupIDByType(
+	     client, stuff->window, XRT_WINDOW, DixUnknownAccess)))
+	return BadWindow;
+
+    FOR_NSCREENS_FORWARD(j) {
+	stuff->window = win->info[j].id;
+	rc = (*PanoramiXSaveCompositeVector[stuff->compositeReqType]) (client);
+	if (rc != Success) break;
+    }
+
+    return (rc);
+}
+
+static int
+PanoramiXCompositeRedirectSubwindows (ClientPtr client)
+{
+    PanoramiXRes *win;
+    int rc = 0, j;
+    REQUEST(xCompositeRedirectSubwindowsReq);
+
+    REQUEST_SIZE_MATCH(xCompositeRedirectSubwindowsReq);
+
+    if(!(win = (PanoramiXRes *)SecurityLookupIDByType(
+	     client, stuff->window, XRT_WINDOW, DixUnknownAccess)))
+	return BadWindow;
+
+    FOR_NSCREENS_FORWARD(j) {
+	stuff->window = win->info[j].id;
+	rc = (*PanoramiXSaveCompositeVector[stuff->compositeReqType]) (client);
+	if (rc != Success) break;
+    }
+
+    return (rc);
+}
+
+static int
+PanoramiXCompositeUnredirectWindow (ClientPtr client)
+{
+    PanoramiXRes *win;
+    int rc = 0, j;
+    REQUEST(xCompositeUnredirectWindowReq);
+
+    REQUEST_SIZE_MATCH(xCompositeUnredirectWindowReq);
+
+    if(!(win = (PanoramiXRes *)SecurityLookupIDByType(
+	     client, stuff->window, XRT_WINDOW, DixUnknownAccess)))
+	return BadWindow;
+
+    FOR_NSCREENS_FORWARD(j) {
+	stuff->window = win->info[j].id;
+	rc = (*PanoramiXSaveCompositeVector[stuff->compositeReqType]) (client);
+	if (rc != Success) break;
+    }
+
+    return (rc);
+}
+
+static int
+PanoramiXCompositeUnredirectSubwindows (ClientPtr client)
+{
+    PanoramiXRes *win;
+    int rc = 0, j;
+    REQUEST(xCompositeUnredirectSubwindowsReq);
+
+    REQUEST_SIZE_MATCH(xCompositeUnredirectSubwindowsReq);
+
+    if(!(win = (PanoramiXRes *)SecurityLookupIDByType(
+	     client, stuff->window, XRT_WINDOW, DixUnknownAccess)))
+	return BadWindow;
+
+    FOR_NSCREENS_FORWARD(j) {
+	rc = (*PanoramiXSaveCompositeVector[stuff->compositeReqType]) (client);
+	if (rc != Success) break;
+    }
+
+    return (rc);
+}
+
+static int
+PanoramiXCompositeNameWindowPixmap (ClientPtr client)
+{
+    WindowPtr	    pWin;
+    CompWindowPtr   cw;
+    PixmapPtr	    pPixmap;
+    int rc;
+    PanoramiXRes *win, *newPix;
+    int i;
+    REQUEST(xCompositeNameWindowPixmapReq);
+
+    REQUEST_SIZE_MATCH(xCompositeNameWindowPixmapReq);
+
+    if(!(win = (PanoramiXRes *)SecurityLookupIDByType(
+	     client, stuff->window, XRT_WINDOW, DixUnknownAccess)))
+    {
+	client->errorValue = stuff->window;
+	return BadWindow;
+    }
+
+    if(!(newPix = (PanoramiXRes *) xalloc(sizeof(PanoramiXRes))))
+	return BadAlloc;
+
+    LEGAL_NEW_RESOURCE (stuff->pixmap, client);
+
+    newPix->type = XRT_PIXMAP;
+    newPix->u.pix.shared = FALSE;
+    newPix->info[0].id = stuff->pixmap;
+
+    for (i = 1; i < PanoramiXNumScreens; i++)
+	newPix->info[i].id = FakeClientID (client->index);
+
+    FOR_NSCREENS(i) {
+	rc = dixLookupResource ((pointer *) &pWin,
+				win->info[i].id, RT_WINDOW, client,
+				DixGetAttrAccess);
+	if (rc != Success)
+	{
+	    client->errorValue = stuff->window;
+	    xfree (newPix);
+	    return (rc == BadValue) ? BadWindow : rc;
+	}
+
+	if (!pWin->viewable)
+	{
+	    xfree (newPix);
+	    return BadMatch;
+	}
+
+	cw = GetCompWindow (pWin);
+	if (!cw)
+	{
+	    xfree (newPix);
+	    return BadMatch;
+	}
+
+	pPixmap = (*pWin->drawable.pScreen->GetWindowPixmap) (pWin);
+	if (!pPixmap)
+	{
+	    xfree (newPix);
+	    return BadMatch;
+	}
+
+	if (!AddResource (newPix->info[i].id, RT_PIXMAP,
+			  (pointer) pPixmap))
+	    return BadAlloc;
+
+	++pPixmap->refcnt;
+    }
+
+    if (!AddResource (stuff->pixmap, XRT_PIXMAP, (pointer) newPix))
+	return BadAlloc;
+
+    return (client->noClientException);
+}
+
+
+static int
+PanoramiXCompositeGetOverlayWindow (ClientPtr client)
+{
+    REQUEST(xCompositeGetOverlayWindowReq);
+    xCompositeGetOverlayWindowReply rep;
+    WindowPtr pWin;
+    ScreenPtr pScreen;
+    CompScreenPtr cs;
+    CompOverlayClientPtr pOc;
+    int rc;
+    PanoramiXRes *win, *overlayWin = NULL;
+    int i;
+
+    REQUEST_SIZE_MATCH(xCompositeGetOverlayWindowReq);
+
+    if(!(win = (PanoramiXRes *)SecurityLookupIDByType(
+	     client, stuff->window, XRT_WINDOW, DixUnknownAccess)))
+    {
+	client->errorValue = stuff->window;
+	return BadWindow;
+    }
+
+    cs = GetCompScreen(screenInfo.screens[0]);
+    if (!cs->pOverlayWin)
+    {
+	if(!(overlayWin = (PanoramiXRes *) xalloc(sizeof(PanoramiXRes))))
+	    return BadAlloc;
+
+	overlayWin->type = XRT_WINDOW;
+	overlayWin->u.win.root = FALSE;
+    }
+
+    FOR_NSCREENS_BACKWARD(i) {
+	rc = dixLookupResource((pointer *)&pWin, win->info[i].id,
+			       RT_WINDOW, client,
+			       DixGetAttrAccess);
+	if (rc != Success)
+	{
+	    client->errorValue = stuff->window;
+	    return (rc == BadValue) ? BadWindow : rc;
+	}
+	pScreen = pWin->drawable.pScreen;
+
+	/*
+	 * Create an OverlayClient structure to mark this client's
+	 * interest in the overlay window
+	 */
+	pOc = compCreateOverlayClient(pScreen, client);
+	if (pOc == NULL)
+	    return BadAlloc;
+
+	/*
+	 * Make sure the overlay window exists
+	 */
+	cs = GetCompScreen(pScreen);
+	if (cs->pOverlayWin == NULL)
+	    if (!compCreateOverlayWindow(pScreen))
+	    {
+		FreeResource (pOc->resource, RT_NONE);
+		return BadAlloc;
+	    }
+
+	rc = XaceHook(XACE_RESOURCE_ACCESS, client,
+		      cs->pOverlayWin->drawable.id,
+		      RT_WINDOW, cs->pOverlayWin, RT_NONE, NULL,
+		      DixGetAttrAccess);
+	if (rc != Success)
+	{
+	    FreeResource (pOc->resource, RT_NONE);
+	    return rc;
+	}
+    }
+
+    if (overlayWin)
+    {
+	FOR_NSCREENS(i) {
+	    cs = GetCompScreen(screenInfo.screens[i]);
+	    overlayWin->info[i].id = cs->pOverlayWin->drawable.id;
+	}
+
+	AddResource(overlayWin->info[0].id, XRT_WINDOW, overlayWin);
+    }
+
+    cs = GetCompScreen(screenInfo.screens[0]);
+
+    rep.type = X_Reply;
+    rep.sequenceNumber = client->sequence;
+    rep.length = 0;
+    rep.overlayWin = cs->pOverlayWin->drawable.id;
+
+    if (client->swapped)
+    {
+	int n;
+	swaps(&rep.sequenceNumber, n);
+	swapl(&rep.length, n);
+	swapl(&rep.overlayWin, n);
+    }
+    (void) WriteToClient(client, sz_xCompositeGetOverlayWindowReply, (char *)&rep);
+
+    return client->noClientException;
+}
+
+static int
+PanoramiXCompositeReleaseOverlayWindow (ClientPtr client)
+{
+    REQUEST(xCompositeReleaseOverlayWindowReq);
+    WindowPtr pWin;
+    ScreenPtr pScreen;
+    CompOverlayClientPtr pOc;
+    PanoramiXRes *win;
+    int i;
+
+    REQUEST_SIZE_MATCH(xCompositeReleaseOverlayWindowReq);
+
+    if(!(win = (PanoramiXRes *)SecurityLookupIDByType(
+	     client, stuff->window, XRT_WINDOW, DixUnknownAccess)))
+    {
+	client->errorValue = stuff->window;
+	return BadWindow;
+    }
+
+    FOR_NSCREENS_BACKWARD(i) {
+	pWin = (WindowPtr) LookupIDByType (win->info[i].id, RT_WINDOW);
+	if (!pWin)
+	{
+	    client->errorValue = stuff->window;
+	    return BadWindow;
+	}
+	pScreen = pWin->drawable.pScreen;
+
+	/*
+	 * Has client queried a reference to the overlay window
+	 * on this screen? If not, generate an error.
+	 */
+	pOc = compFindOverlayClient (pWin->drawable.pScreen, client);
+	if (pOc == NULL)
+	    return BadMatch;
+
+	/* The delete function will free the client structure */
+	FreeResource (pOc->resource, RT_NONE);
+    }
+
+    return client->noClientException;
+}
+
+void
+PanoramiXCompositeInit (void)
+{
+    int i;
+
+    for (i = 0; i < CompositeNumberRequests; i++)
+	PanoramiXSaveCompositeVector[i] = ProcCompositeVector[i];
+    /*
+     * Stuff in Xinerama aware request processing hooks
+     */
+    ProcCompositeVector[X_CompositeRedirectWindow] =
+	PanoramiXCompositeRedirectWindow;
+    ProcCompositeVector[X_CompositeRedirectSubwindows] =
+	PanoramiXCompositeRedirectSubwindows;
+    ProcCompositeVector[X_CompositeUnredirectWindow] =
+	PanoramiXCompositeUnredirectWindow;
+    ProcCompositeVector[X_CompositeUnredirectSubwindows] =
+	PanoramiXCompositeUnredirectSubwindows;
+    ProcCompositeVector[X_CompositeNameWindowPixmap] =
+	PanoramiXCompositeNameWindowPixmap;
+    ProcCompositeVector[X_CompositeGetOverlayWindow] =
+	PanoramiXCompositeGetOverlayWindow;
+    ProcCompositeVector[X_CompositeReleaseOverlayWindow] =
+	PanoramiXCompositeReleaseOverlayWindow;
+}
+
+void
+PanoramiXCompositeReset (void)
+{
+    int i;
+
+    for (i = 0; i < CompositeNumberRequests; i++)
+	ProcCompositeVector[i] = PanoramiXSaveCompositeVector[i];
+}
+
+#endif
Index: xorg-server-7.2.0.0-1.5.99.1/composite/compint.h
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/composite/compint.h
+++ xorg-server-7.2.0.0-1.5.99.1/composite/compint.h
@@ -319,4 +319,9 @@ CompositeRealChildHead (WindowPtr pWin);
 int
 DeleteWindowNoInputDevices(pointer value, XID wid);
 
+#ifdef PANORAMIX
+void PanoramiXCompositeInit (void);
+void PanoramiXCompositeReset (void);
+#endif
+
 #endif /* _COMPINT_H_ */
Index: xorg-server-7.2.0.0-1.5.99.1/composite/compoverlay.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/composite/compoverlay.c
+++ xorg-server-7.2.0.0-1.5.99.1/composite/compoverlay.c
@@ -47,6 +47,10 @@
 #include "compint.h"
 #include "xace.h"
 
+#ifdef PANORAMIX
+#include "panoramiXsrv.h"
+#endif
+
 /* 
  * Delete the given overlay client list element from its screen list.
  */
@@ -127,10 +131,20 @@ compCreateOverlayWindow (ScreenPtr pScre
     WindowPtr	    pWin;
     XID		    overrideRedirect = TRUE;
     int		    result;
+    int		    w = pScreen->width;
+    int		    h = pScreen->height;
+
+#ifdef PANORAMIX
+    if (!noPanoramiXExtension)
+    {
+	w = PanoramiXPixWidth;
+	h = PanoramiXPixHeight;
+    }
+#endif
 
     pWin = cs->pOverlayWin = 
 	CreateWindow (cs->overlayWid, pRoot,
-		      0, 0, pScreen->width, pScreen->height, 0, 
+		      0, 0, w, h, 0,
 		      InputOutput, CWOverrideRedirect, &overrideRedirect,
 		      pRoot->drawable.depth, 
 		      serverClient, pScreen->rootVisual, &result);
Index: xorg-server-7.2.0.0-1.5.99.1/composite/compwindow.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/composite/compwindow.c
+++ xorg-server-7.2.0.0-1.5.99.1/composite/compwindow.c
@@ -46,6 +46,10 @@
 
 #include "compint.h"
 
+#ifdef PANORAMIX
+#include "panoramiXsrv.h"
+#endif
+
 #ifdef COMPOSITE_DEBUG
 static int
 compCheckWindow (WindowPtr pWin, pointer data)
@@ -171,16 +175,26 @@ updateOverlayWindow(ScreenPtr pScreen)
 	CompScreenPtr cs;
 	WindowPtr pWin; /* overlay window */
 	XID vlist[2];
+	int w = pScreen->width;
+	int h = pScreen->height;
+
+#ifdef PANORAMIX
+	if (!noPanoramiXExtension)
+	{
+	    w = PanoramiXPixWidth;
+	    h = PanoramiXPixHeight;
+	}
+#endif
 
 	cs = GetCompScreen(pScreen);
 	if ((pWin = cs->pOverlayWin) != NULL) {
-		if ((pWin->drawable.width == pScreen->width) &&
-			(pWin->drawable.height == pScreen->height))
+		if ((pWin->drawable.width == w) &&
+			(pWin->drawable.height == h))
 			return Success;
 
 		/* Let's resize the overlay window. */
-		vlist[0] = pScreen->width;
-		vlist[1] = pScreen->height;
+		vlist[0] = w;
+		vlist[1] = h;
 		return ConfigureWindow(pWin, CWWidth | CWHeight, vlist, wClient(pWin));
 	}
 
